#ifndef _FIR_H
#define _FIR_H

#include "dsplib/fir_types.h"

#include <vector>

// print fir contents
void print_fir (const intfir_t * fir);
void print_dblfir (const dblfir_t * fir);

// Validator for intfir_t struct, returns 1 when ok, 0 if bad
int fir_valid (const intfir_t * fir);

// File I/O
int readfir (const char *fn, intfir_t * fir);
int writefir (const char *fn, const intfir_t * fir);

//void deletefir(intfir_t *fir);

// Deconvolution filter generation
int create_deconvolution_dblFIR (dblfir_t * engine, const std::vector<double> &imp_orig, const std::vector<double> &imp_req, double orig_thr, double req_thr);

// Do convolution with range checking
//  void fir_convolve (const intfir_t * fir, const int *in, unsigned int inlen, int *out, unsigned int outlen);
// in - short int, out - int
void fir_convolve_s (const intfir_t * fir, const short int *in, unsigned int inlen, int *out, unsigned int outlen);
//  void fir_convolve_d (const intfir_t * fir, const double *in, unsigned int inlen, double *out, unsigned int outlen);

#endif                          /* _FIR_H */
